//+------------------------------------------------------------------+
//|                                                Deriv Warrior.mq5 |
//|                WhatsApp +27651351609 created by Marius Slinning  |
//|      the only system you make money with                      
//+------------------------------------------------------------------+
#property copyright "Amos Tsopotsa,Telegram link ,https://t.me/+JxCz659JUMRjOTg8"
#property link      "https://t.me/+JxCz659JUMRjOTg8"
#property version   "1.00"

//+------------------------------------------------------------------+
//| Include files                                                    |
//+------------------------------------------------------------------+
#include <Trade\AccountInfo.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\Trade.mqh>

CAccountInfo   acc;
CSymbolInfo    smb;
CPositionInfo  psn;
CTrade         trd;

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
enum ENUM_DIR
{
   Dir0, // Buy&Sell
   Dir1, // Only buy
   Dir2  // Only sell
};

input string          str1           = "===== MAIN SETTINGS ====="; // -----
input ENUM_DIR        Direction      = 0;           // Direction
input int             NmbOrdPerSign  = 1;           // Number of trades per signal
input double          Lots           = 1.00;        // Lot size
input int             StopLoss       = 0;           // Stop loss in points
input int             NmbSec         = 30;          // Take profit
input int             MagicNumber    = 48322;       // Magic number

int                   Slippage       = 50;          // Max slippage

ulong ord_ticket;
int NmbBuy, NmbSell;
double Lot, SL, TP;
datetime LastTime;
bool Testing;

datetime ExpiryDate = D'2022.09.30 00:00';
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   if (TimeCurrent() >= ExpiryDate)
   {
      Alert("The Expert Advisor has expired.");
      return(INIT_FAILED);
   }
   
   if (!smb.Name(_Symbol)) return INIT_FAILED;
   smb.Refresh();
   
   trd.SetDeviationInPoints(Slippage);
   trd.SetExpertMagicNumber(MagicNumber);
   
   if (LastTime == 0) LastTime = iTime(smb.Name(), 0, 1);
   Testing = MQLInfoInteger(MQL_TESTER);
   
   EventSetTimer(1);
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   EventKillTimer();
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
   smb.RefreshRates();
   CountTrades();
   
   if (Testing) OnTick();
   
   if (NmbBuy+NmbSell == 0)
   {
      if (iBarShift(smb.Name(), 0, LastTime) > 0)
      {
         if (Direction != 2 && SignalBuy())
         {
            Lot = NL(Lots);
            for (int i=1; i<=NmbOrdPerSign; i++)
            {
               if (CheckMoneyForTrade(ORDER_TYPE_BUY, Lot, smb.Ask()))
               {
                  if (trd.Buy(Lot))
                  {
                     ord_ticket = trd.ResultOrder();
                     if (ord_ticket < 0) Print("Error: "+IntegerToString(GetLastError()));
                     else
                     {
                        SL = NormalizeDouble(smb.Ask()-StopLoss*smb.Point(), smb.Digits()); if (StopLoss <= 0) SL = 0;
                        trd.PositionModify(ord_ticket, SL, 0);
                        
                        NmbBuy++;
                        LastTime = TimeCurrent();
                     }
                  }
               }
            }
         }
         if (Direction != 1 && SignalSell())
         {
            Lot = NL(Lots);
            for (int i=1; i<=NmbOrdPerSign; i++)
            {
               if (CheckMoneyForTrade(ORDER_TYPE_SELL, Lot, smb.Bid()))
               {
                  if (trd.Sell(Lot))
                  {
                     ord_ticket = trd.ResultOrder();
                     if (ord_ticket < 0) Print("Error: "+IntegerToString(GetLastError()));
                     else
                     {
                        SL = NormalizeDouble(smb.Bid()+StopLoss*smb.Point(), smb.Digits()); if (StopLoss <= 0) SL = 0;
                        trd.PositionModify(ord_ticket, SL, 0);
                        
                        NmbSell++;
                        LastTime = TimeCurrent();
                     }
                  }
               }
            }
         }
      }
   }
}
//+------------------------------------------------------------------+
void OnTimer()
{
   for (int i=PositionsTotal()-1; i>=0; i--)
   {
      if(psn.SelectByIndex(i) && psn.Symbol() == smb.Name() && psn.Magic() == MagicNumber)
      {
         if (TimeCurrent() >= psn.Time()+NmbSec) CloseOrderByTicket(psn.Ticket());
      }
   }
}
//+------------------------------------------------------------------+
void CountTrades()
{
   NmbBuy = 0; NmbSell = 0;
   for (int i=PositionsTotal()-1; i>=0; i--)
   {
      if(psn.SelectByIndex(i) && psn.Symbol() == smb.Name() && psn.Magic() == MagicNumber)
      {
         if (psn.PositionType() == POSITION_TYPE_BUY)  NmbBuy++;
         if (psn.PositionType() == POSITION_TYPE_SELL) NmbSell++;
      }
   }
}
//+------------------------------------------------------------------+
void CloseOrderByTicket(ulong oticket)
{
   int try=0;
   while(try<1)
   {
      bool cls=trd.PositionClose(oticket);
      if(cls) break;
      Sleep(100);
      try++;
   }
}
//+------------------------------------------------------------------+
bool SignalBuy()
{
   if (iOpen(smb.Name(), 0, 0) > iOpen(smb.Name(), 0, 1)) return(true);
   return(false);
}
//+------------------------------------------------------------------+
bool SignalSell()
{
   if (iOpen(smb.Name(), 0, 0) < iOpen(smb.Name(), 0, 1)) return(true);
   return(false);
}
//+------------------------------------------------------------------+
double NL(double lot)
{
   return (MathMin(MathMax(MathRound(lot/smb.LotsStep())*smb.LotsStep(),smb.LotsMin()),smb.LotsMax()));
}
//+------------------------------------------------------------------+
bool CheckMoneyForTrade(ENUM_ORDER_TYPE type,double volume,double price)
{
   double margin = 0;
   double marginFree = acc.FreeMargin();
   
   if (!OrderCalcMargin(type,smb.Name(),volume,price,margin))
      return false;
   
   if (margin > marginFree)
      return false;
   
   return true;
}
//+------------------------------------------------------------------+